<template>
    <div class="albums">
        <label>
            Jahr:
            <select name="year" v-model="search.year" @change="filter">
                <option value="all">Alle</option>
                <option v-for="y in search.years" :value="y">{{y}}</option>
            </select>
        </label>
        <br><br>

        <router-link :to="{ name: 'album', params: { id: item.id } }" tag="a"
                     v-for="item in albums" :key="item.id"
                     class="albumcover"
        >
            <img :src="item.thumbUrl ? item.thumbUrl : 'https://placeimg.com/200/200/any'"
                 :alt="item.date + ' ' + item.title">
            <div class="albumcover__details">
                <b>{{item.date}}</b>
                <br>
                {{item.title}}
            </div>
        </router-link>
    </div>
</template>

<script>
    export default {
        data() {
            return {
                search: {
                    year: this.$store.state.search.year,
                    years:
                        [...Array(this.$store.state.maxYear-this.$store.state.minYear+1).keys()]
                            .map(y => y+=this.$store.state.minYear).reverse(),
                },

                albums: this.$store.state.albums,
            };
        },

        mounted() {
            this.init();
        },

        methods: {
            init() {
                // set data
                if (!this.albums.length) {
                    this.$mediaApi.call('getAlbumsByDate', { year: this.search.year }, (res) => {
                        this.albums = res;
                        this.$store.commit('setAlbums', res);
                    });
                }
            },

            filter() {
                this.$store.commit('setSearch', this.search);

                if (this.search.year === 'all') {
                    this.$el.classList.add('all');
                    this.$mediaApi.call('getAlbums', {}, (res) => {
                        this.albums = res;
                        this.$store.commit('setAlbums', res);
                    });
                }
                else {
                    this.$el.classList.remove('all');
                    this.$mediaApi.call('getAlbumsByDate', { year: this.search.year }, (res) => {
                        this.albums = res;
                        this.$store.commit('setAlbums', res);
                    });
                }
            },
        },
    }
</script>

<style lang="scss">
    .albums {
        /*
        &.all {
            .albumcover {
                width: 100px;
                height: 100px;
                margin-right: 10px;
                margin-bottom: 10px;

                &__details {
                    min-height: 50px;
                    font-size: 0.75em;
                }
            }
        }
        */
    }

    .albumcover {
        position: relative;
        float: left;

        display: inline-block;
        width: 200px;
        height: 200px;

        padding: 0;
        margin-right: 15px;
        margin-bottom: 15px;
        border: none;

        opacity: 1;
        transition: opacity 0.3s;

        cursor: pointer;

        box-shadow: 3px 3px 5px 0 #222;

        overflow: hidden;
        img {
            max-width: none !important;
            min-width: 100%;
            min-height: 100%;
            position: absolute;
            left: 0; top: 0;
            margin-left: 50%;
            margin-top: 50%;
            transform: translate(-50%, -50%);
        }

        &:hover {
            opacity: 0.8;
        }

        &__details {
            position: absolute;
            bottom: 0; left: 0;

            width: 100%;
            min-height: 70px;

            color: #fff;
            background: rgba(0, 0, 0, 0.5);

            padding: 5px;

            box-sizing: border-box;
            line-height: 1.2em;
        }
    }

    select[name="year"] {
        background-image: linear-gradient(to bottom, #ffffff, #f3f3f3);
        box-shadow: 0 1px 3px #bcbcbc;
    }
</style>
